; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

[Setup]
UsePreviousAppDir=no
ArchitecturesInstallIn64BitMode=x64
AppName=PL/R for PostgreSQL (x64)
AppVerName=PL/R 8.3.0.11 (x64)
AppPublisher=http://www.joeconway.com/plr/
AppPublisherURL=http://www.joeconway.com/plr/
AppSupportURL=http://www.joeconway.com/plr/
AppUpdatesURL=http://www.joeconway.com/plr/
DefaultDirName=C:\Program Files\PostgreSQL\9.0
DefaultGroupName=R Procedural Language for PostgreSQL (x64)
DisableProgramGroupPage=yes
LicenseFile=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\COPYING
InfoBeforeFile=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\infobeforeinstall.txt
InfoAfterFile=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\infoafterinstall.txt
OutputDir=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\
OutputBaseFilename=plr-8.3.0.11_pg90_r211_win64
Compression=lzma
SolidCompression=yes
WizardImageFile=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\elephant.bmp
WizardSmallImageFile=C:\plr\plr-8.3.0.11-pg90-r211-win64-setup-src\r-logo.bmp
ChangesEnvironment=true
[Languages]
Name: english; MessagesFile: compiler:Default.isl

[Files]
Source: C:\plr\plr-8.3.0.11-pg90-r211.win64\doc\*; DestDir: {app}\doc\contrib\plr; Flags: ignoreversion
Source: C:\plr\plr-8.3.0.11-pg90-r211.win64\plr.dll; DestDir: {app}\lib; Flags: ignoreversion
Source: C:\plr\plr-8.3.0.11-pg90-r211.win64\plr.sql; DestDir: {app}\share\contrib\; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files
[Code]
var RestartRequired: Boolean;
var RRealPath: String;
var myPATH : String;
var Rhome: String;
procedure InitializeWizard();
var PgPath: String;
begin
  RegQueryStringValue(HKEY_LOCAL_MACHINE,'SOFTWARE\PostgreSQL\Installations\postgresql-x64-9.0','Base Directory',PgPath);
  WizardForm.DirEdit.Text := PgPath;
end;

function InitializeSetUp():Boolean;
begin
	RestartRequired := false;
	Result := false;
	RegQueryStringValue(HKEY_LOCAL_MACHINE,'SOFTWARE\R-core\R','InstallPath',RRealPath);
	RegQueryStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\Session Manager\Environment','Path',myPATH);
	RegQueryStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\Session Manager\Environment','R_HOME',Rhome);
	if IsWin64=False then
	  begin
	  MsgBox('This version of R must be installed in a 64-bit operating system.',mbError,MB_DEFBUTTON2);
	  exit
	end;

	if FileExists(AddBackslash(RRealPath)+'\bin\R.dll') then
	begin
		if pos(RRealPath+'\bin',myPATH)>0 then
		begin
			if pos(Rhome,RRealPath)>0 then
			begin
				Result := true;
			end
			else
			begin
				if MsgBox('NOTES: It seems that R is installed in this computer and "'+ RRealPath +'\bin" is present in your PATH environment variable. However, the R_HOME environment variable was not found (i.e., R_HOME = "'+RRealPath + '"). This installer will add this variable if you continue. PL/R must also be installed in the same location as your PostgreSQL 9.0.x installation. Would you like to continue?',mbConfirmation,MB_YESNO)= IDNO then exit
				else
				begin
					RestartRequired := true;
					RegWriteStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\Session Manager\Environment','R_HOME',RRealPath);
					Result := true;
				end
			end
		end;
		if pos(RRealPath+'\bin',myPATH)=0 then
		begin
			if MsgBox('NOTES: It seems that R is installed in this computer at "'+ RRealPath +'". This installer will add the R_HOME environment variable (i.e., R_HOME = "'+RRealPath + '"), and add "'+RRealPath + '\bin" to the PATH environment variable if you continue. PL/R must also be installed in the same location as your PostgreSQL 9.0.x installation. Would you like to continue?',mbConfirmation,MB_YESNO)= IDNO
				then exit
			else
			begin
				RestartRequired := true;
				RegWriteStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\Session Manager\Environment','R_HOME',RRealPath);
				RegWriteStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\Session Manager\Environment','Path',myPATH+';'+RRealPath+'\bin');
				Result := true;
			end
		end
	end
	else
	begin
		if MsgBox('It seems that R is not installed  in this computer, please install it from http://probability.ca/cran/bin/windows/base/R-2.11.1-win64.exe',mbError,MB_DEFBUTTON2)=IDOK
		then exit
	end;

	if RestartRequired then
	begin
		MsgBox('Due to changes in environment variables (either R_HOME or Path), you must either reboot or restart the PostgreSQL database service after the installation is complete.',mbInformation,MB_OK)
	end;

	Result := true;

end;

[Icons]
Name: "{group}\{cm:UninstallProgram,R Procedural Language for PostgreSQL}"; Filename: "{uninstallexe}"
[Registry]
;Root: HKLM; Subkey: SYSTEM\CurrentControlSet\Control\Session Manager\Environment; ValueType: expandsz; ValueName: PATH; ValueData: "{olddata};{app}\bin;{app}\lib"
